unit colorbar;

interface

uses
{$IFDEF FPC}LResources,  {$ELSE}
   Windows,
  {$ENDIF}
   Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls,define_types, ExtCtrls,Prefs;

type
  { TColorbarForm }
  TColorbarForm = class(TForm)
    BarPanel: TPanel;
    BottomTrack: TTrackBar;
    ColorbarCheck: TCheckBox;
    ColorbarTextCheck: TCheckBox;
    FramePanel: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    LeftTrack: TTrackBar;
    RightTrack: TTrackBar;
    TopTrack: TTrackBar;
    procedure ColorbarTrackChange(Sender: TObject);
    procedure DemoBar (lU: TUnitRect);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure ShowDefs (lPrefs: TPrefs);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ColorbarForm: TColorbarForm;

implementation
{$IFNDEF FPC}
{$R *.dfm}
{$ENDIF}


uses mainunit;

procedure TColorbarForm.DemoBar (lU: TUnitRect);
begin
    BarPanel.left := round(lU.L * FramePanel.Width);
    BarPanel.top := FramePanel.Height-round(lU.T * FramePanel.Height);
    BarPanel.width := round(abs(lU.L-lU.R) * FramePanel.Height);
    BarPanel.height := round(abs(lU.B-lU.T) * FramePanel.Height);
end;

procedure TColorbarForm.ColorbarTrackChange(Sender: TObject);
var
  lL,lT,lR,lB: single;
begin
  if not ColorbarForm.Visible then exit;
  gPrefs.Colorbar := ColorBarCheck.Checked;
  gPrefs.ColorbarText := ColorbarTextCheck.Checked;
  lL := LeftTrack.Position / LeftTrack.Max;
  lR := RightTrack.Position / RightTrack.Max;
{$IFDEF Darwin}
  lT := (TopTrack.Position / TopTrack.Max);
  lB := (BottomTrack.Position / BottomTrack.Max);
{$ELSE}
  lT := 1-(TopTrack.Position / TopTrack.Max);
  lB := 1-(BottomTrack.Position / BottomTrack.Max);
{$ENDIF}
  gPrefs.ColorBarPos:= CreateUnitRect (lL,lT,lR,lB);
  SensibleUnitRect(gPrefs.ColorBarPos);
  DemoBar (gPrefs.ColorBarPos);
  GLForm1.UpdateTimer.enabled := true;
end;

procedure TColorbarForm.ShowDefs (lPrefs: TPrefs);
var
  lL,lT,lR,lB: single;
begin
  lL := lPrefs.ColorBarPos.L;
  lT := 1-lPrefs.ColorBarPos.T;
  lR := lPrefs.ColorBarPos.R;
  lB := 1-lPrefs.ColorBarPos.B;
{$IFDEF Darwin}
  TopTrack.Position := round((1-lT) * TopTrack.Max);
  BottomTrack.Position := round((1-lB)* BottomTrack.Max);

{$ELSE}
  TopTrack.Position := round(lT * TopTrack.Max);
  BottomTrack.Position := round(lB* BottomTrack.Max);
{$ENDIF}
  LeftTrack.Position := round(lL* LeftTrack.Max);
  RightTrack.Position := round(lR* RightTrack.Max);

  Colorbarcheck.checked := lPrefs.Colorbar;
  ColorbarTextCheck.Checked := lPrefs.ColorbarText;

end;

procedure TColorbarForm.FormShow(Sender: TObject);
(*var
  lL,lT,lR,lB: single;
begin
  lL := gPrefs.ColorBarPos.L;
  lT := 1-gPrefs.ColorBarPos.T;
  lR := gPrefs.ColorBarPos.R;
  lB := 1-gPrefs.ColorBarPos.B;
  TopTrack.Position := round(lT * TopTrack.Max);
  BottomTrack.Position := round(lB* BottomTrack.Max);
  LeftTrack.Position := round(lL* LeftTrack.Max);
  RightTrack.Position := round(lR* RightTrack.Max);*)
begin
  ShowDefs(gPRefs);
end;

procedure TColorbarForm.FormCreate(Sender: TObject);
begin
//  Colorbarcheck.checked := gPrefs.Colorbar;
//  ColorbarTextCheck.Checked := gPrefs.ColorbarText;
end;

procedure TColorbarForm.FormClose(Sender: TObject;
  var CloseAction: TCloseAction);
begin
   gPrefs.Colorbar := Colorbarcheck.checked;

end;

initialization
{$IFDEF FPC}
  {$I colorbar.lrs}
{$ENDIF}
end.
