unit nii_save;
interface
uses
 nifti_hdr, define_types,texture_3d_unit,dialogs, sysutils;

function Tex2NII ( lInFilename: string; lTexture: TTexture): boolean;
implementation

function Tex2NII (lInFilename: string; lTexture: TTexture): boolean;
var lHdr: TNIFTIhdr;
  lnVox,lDummy: integer;
	lFilename,lExt: string;
    lF: File;
    lOverwrite: boolean;
begin
  lFilename := lInFilename;
     move(lTexture.NIFTIhdr, lHdr, sizeof(lHdr));
    lnVox := lHdr.dim[1]*lHdr.dim[2]*lHdr.dim[3];
    if (lTexture.EdgeImg = nil) or (lnVox < 1)  then begin
      showmessage('nii_save error: no edge image loaded.');
      exit;
    end;
     lHdr.dim[4] := 1;
     lHdr.dim[0] := 3;//3D data
     lHdr.bitpix := 8;
     lHdr.vox_offset := sizeof(lHdr)+4;//348+4 = 352 -> divisible by 8
     lHdr.datatype := kDT_UNSIGNED_CHAR;
     FixDataType (lHdr);

     lOverwrite := false; //will we overwrite existing file?
     result := false; //assume failure
	 if lHdr.magic = kNIFTI_MAGIC_EMBEDDED_HDR then begin
		 lExt := UpCaseExt(lFileName);
		 if (lExt = '.GZ') or (lExt = '.NII.GZ') then begin
			showmessage('Unable to save .nii.gz headers (first ungzip your image if you wish to edit the header)');
			exit;
		 end;
		 lFilename := changefileext(lFilename,'.nii')
	 end else
         lFilename := changefileext(lFilename,'.hdr');
     if ((sizeof(TNIFTIhdr))> DiskFreeEx(lFileName)) then begin
        ShowMessage('There is not enough free space on the destination disk to save the header. '+kCR+
        lFileName+ kCR+' Bytes Required: '+inttostr(sizeof(TNIFTIhdr)) );
        exit;
     end;
     if Fileexists(lFileName) then begin
         showmessage('Error: the file '+lFileName+' already exists.');
         exit;
         (*if lAllowOverwrite then begin
            case MessageDlg('Do you wish to modify the existing file '+lFilename+'?', mtConfirmation,[mbYes, mbNo], 0) of	{ produce the message dialog box }
             6: lOverwrite := true; //6= mrYes, 7=mrNo... not sure what this is for Linux. Hardcoded as we do not include Form values
        end;//case
         end else
             showmessage('Error: the file '+lFileName+' already exists.');
         if not lOverwrite then Exit;   *)
	 end;
	 if lHdr.magic = kNIFTI_MAGIC_EMBEDDED_HDR then
		if lHdr.vox_offset < sizeof(TNIFTIHdr) then
		   lHdr.vox_offset := sizeof(TNIFTIHdr); //embedded images MUST start after header
	 if lHdr.magic = kNIFTI_MAGIC_SEPARATE_HDR then
		   lHdr.vox_offset := 0; //embedded images MUST start after header
     result := true;
     Filemode := 1;
     AssignFile(lF, lFileName); {WIN}
     if lOverwrite then //this allows us to modify just the 348byte header of an existing NII header without touching image data
         Reset(lF,1)
     else
         Rewrite(lF,1);
     BlockWrite(lF,lHdr, sizeof(TNIFTIhdr));
     lDummy := 0;
     BlockWrite(lF,lDummy,4);
     BlockWrite(lF,lTexture.EdgeImg^,lnVox);
     CloseFile(lF);
     Filemode := 2;
end; //func NIFTIhdr_SaveHdr



end.
 