unit uprefsform;

interface
{$include options.inc}

{$IFDEF FPC}{$mode DELPHI}{$H+}{$ENDIF}
uses
{$IFDEF FPC}LResources,
{$ELSE} //Delphi   Windows,
{$ENDIF}
   Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,define_types,prefs;
type
  { TPrefsForm }
  TPrefsForm = class(TForm)
    IntelCheck: TCheckBox;
    RenderDrop: TComboBox;
    PowerOfTwoCheck: TCheckBox;
    Label1: TLabel;
    GridColorBtn: TButton;
    HistoCOlorBtn: TButton;
    ColorDialog1: TColorDialog;
    TextColorBtn: TButton;
    TextBorderColorBtn: TButton;
    ColorbarborderBtn: TButton;
    Label2: TLabel;
    DefBtn: TButton;
    CancelBtn: TButton;
    OKBtn: TButton;
    //RenderDrop: TComboBox;
    Label3: TLabel;
    procedure CheckChange(Sender: TObject);
    procedure LowResCheckChange(Sender: TObject);
    procedure UpdateXS;
    procedure UpdateZS;
    procedure GridColorBtnClick(Sender: TObject);
    procedure HistoCOlorBtnClick(Sender: TObject);
    procedure TextColorBtnClick(Sender: TObject);
    procedure TextBorderColorBtnClick(Sender: TObject);
    procedure ColorbarborderBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var lAction: TCloseAction);
    procedure DefBtnClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CustomColors;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PrefsForm: TPrefsForm;

implementation

uses mainunit
{$IFDEF ENABLECLUT}, clutprefs  {$ENDIF};
var
  gBackupPrefs: TPrefs;
{$IFNDEF FPC}
{$R *.dfm}
{$ENDIF}

procedure TPrefsForm.UpdateZS;
begin
  PowerOfTwoCheck.Checked := gPrefs.ForcePowerOfTwo;
  IntelCheck.Checked := gPrefs.IntelWarning;
  //fx  (gPrefs.RenderQuality, kNoRender,kNormalRender);
  if (gPrefs.RenderQuality < kNoRender) then
    gPrefs.RenderQuality := kNoRender;
  if  ( gPrefs.RenderQuality > kNormalRender) then
    gPrefs.RenderQuality := kNormalRender;
  RenderDrop.itemindex := gPrefs.RenderQuality;
end;

procedure TPrefsForm.UpdateXS;
begin
  {$IFDEF Darwin}
  GLForm1.SetView(gPrefs.OrthoSliceView,true);
  {$ELSE}
  GLForm1.SetView(gPrefs.OrthoSliceView,true);
  {$ENDIF}
  UpdateZS;
  {$IFDEF ENABLECLUT}
  CLUTForm.HistogramColors;
  {$ENDIF}
end;

procedure TPrefsForm.CheckChange(Sender: TObject);
begin
  if not PrefsForm.Visible then exit;
  //if gPrefs.ForcePowerOfTwo then showmessage('p2') else showmessage('xxx');
  gPrefs.ForcePowerOfTwo:=  PowerOfTwoCheck.checked;
  gPrefs.RenderQuality := RenderDrop.itemindex;
  //gPrefs.LowResolutionRendering:= LowResCheck.Checked;
  UpdateXS;
  GLForm1.OpenMRU(nil);
end;

procedure TPrefsForm.LowResCheckChange(Sender: TObject);
begin
  //gPrefs.LowResolutionRendering:= LowResCheck.Checked;
  if not PrefsForm.Visible then
    exit;
  gPrefs.RenderQuality := RenderDrop.ItemIndex;
    gPrefs.IntelWarning := IntelCheck.checked;
  UpdateXS;
end;

procedure TPrefsForm.CustomColors;
begin
    ColorDialog1.CustomColors.Clear;
    ColorDialog1.CustomColors.Add('ColorA=' + IntToHex(gPrefs.CLUTWindowColor, 6));
    ColorDialog1.CustomColors.Add('ColorB=' + IntToHex(gPrefs.CLUTIntensityColor, 6));
    ColorDialog1.CustomColors.Add('ColorC=' + IntToHex(RGBA2TColor(gPrefs.TextColor), 6));
    ColorDialog1.CustomColors.Add('ColorD=' + IntToHex(RGBA2TColor(gPrefs.TextBorder), 6));
    ColorDialog1.CustomColors.Add('ColorE=' + IntToHex(RGBA2TColor(gPrefs.ColorBarBorder), 6));
end;

procedure TPrefsForm.GridColorBtnClick(Sender: TObject);
begin
    CustomColors;
    ColorDialog1.color := gPrefs.CLUTWindowColor;
    if not ColorDialog1.Execute then begin
      PrefsForm.BringToFront;
      exit;
    end;
    PrefsForm.BringToFront;
    gPrefs.CLUTWindowColor := ColorDialog1.Color;
    UpdateXS;
end;

procedure TPrefsForm.HistoCOlorBtnClick(Sender: TObject);
begin
CustomColors;
    ColorDialog1.color := gPrefs.CLUTIntensityColor;
    if not ColorDialog1.Execute then begin
      PrefsForm.BringToFront;
      exit;
    end;
    PrefsForm.BringToFront;
    gPrefs.CLUTIntensityColor := ColorDialog1.Color;
    UpdateXS;
end;

procedure TPrefsForm.TextColorBtnClick(Sender: TObject);
begin
CustomColors;
   ColorDialog1.color := RGBA2TColor(gPrefs.TextColor);
    if not ColorDialog1.Execute then exit;
    TColor2RGBA (ColorDialog1.Color, gPrefs.TextColor);
    UpdateXS;
end;

procedure TPrefsForm.TextBorderColorBtnClick(Sender: TObject);
begin
CustomColors;
   ColorDialog1.color := RGBA2TColor(gPrefs.TextBorder);
    if not ColorDialog1.Execute then exit;
    TColor2RGBA (ColorDialog1.Color, gPrefs.TextBorder);
    UpdateXS;
end;

procedure TPrefsForm.ColorbarborderBtnClick(Sender: TObject);
begin
CustomColors;
   ColorDialog1.color := RGBA2TColor(gPrefs.ColorBarBorder);
    if not ColorDialog1.Execute then exit;
    TColor2RGBA (ColorDialog1.Color, gPrefs.ColorBarBorder);
    UpdateXS;
end;

procedure TPrefsForm.FormClose(Sender: TObject; var lAction: TCloseAction);
begin
  UpdateXS;
end;

procedure TPrefsForm.DefBtnClick(Sender: TObject);
begin
   SetDefaultPrefs(gPrefs,True);
   UpdateXS;
end;

procedure TPrefsForm.OKBtnClick(Sender: TObject);
begin
  UpdateXS;
  Close;
end;

procedure TPrefsForm.CancelBtnClick(Sender: TObject);
begin
  gPrefs := gBackupPrefs;
  UpdateXS;
  Close;
end;

procedure TPrefsForm.FormShow(Sender: TObject);
begin
  //Please do UpdateZS bBEFORE showing the form - Lazarus generates calls to the checks as soon as the form is shown
  gBackupPrefs := gPrefs;
  RenderDrop.ItemIndex := gPrefs.RenderQuality;
  UpdateXS;
end;

initialization
{$IFDEF FPC}
    {$I uprefsform.lrs}
{$ENDIF}
end.
